<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: gameserver_monitor.php
| Author: bartek124
| E-Mail: bartek124@php-fusion.pl
| Web: http://bartek124.php-fusion.pl
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";

include INFUSIONS."gameserver_monitor_panel/infusion_db.php";

if (file_exists(INFUSIONS."gameserver_monitor_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."gameserver_monitor_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."gameserver_monitor_panel/locale/English.php";
}

define("GSQUERY_DIR", INFUSIONS."gameserver_monitor_panel/includes/");	
include INFUSIONS."gameserver_monitor_panel/includes/gsQuery.php";

if(isset($_GET['server_id']) && !isnum($_GET['server_id'])) { redirect(FUSION_SELF); }
	
if(isset($_GET['server_id'])) {
	$result = dbquery("SELECT * FROM ".DB_GAMESERVERS." WHERE server_id=".$_GET['server_id']);
	if(dbrows($result) != 0) {
		$data = dbarray($result);
		add_to_title(" - ".$locale['gsmp_200'].$data['server_name']);
		
		$ip = $data['server_ip'];
		$port = $data['server_port'];
		$pass = $data['server_pass'];
		$desc = parseubb(nl2br($data['server_description']));
		$protocol = "halflife";
		$gameserver = gsQuery::createInstance($protocol, $ip, $port);
		
		opentable($locale['gsmp_222'].$data['server_name']);
		
		if($gameserver->query_server($protocol, true, false)) {
			$map = stripinput($gameserver->mapname);
			$screen = INFUSIONS."gameserver_monitor_panel/maps/".$map.".jpg";
			$servertitle = stripinput($gameserver->servertitle);
			$numplayers = stripinput($gameserver->numplayers);
			$maxplayers = stripinput($gameserver->maxplayers);
			$gameversion = stripinput($gameserver->gameversion);
			$password = (!empty($data['server_pass']) ? $locale['gsmp_203b']." (".$data['server_pass'].")" : $locale['gsmp_203a']);
			$displayscreen = (file_exists($screen) ? "<img src='".$screen."' alt='".$map."' border='0' width='160' height='120'/>" : "<img src='".INFUSIONS."gameserver_monitor_panel/images/".$locale['gsmp_noimage']."' alt='".$map."' border='0' width='160' height='120' />");
			
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='0' border='0' class='tbl-border' style='margin-top:20px;'>\n";
			echo "<tr>\n<td colspan='3' class='forum-caption' style='text-align:center;font-size:12px;font-weight:bold;'>".$servertitle."</td>\n</tr>\n";
			echo "</table>\n";
			
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='1' border='0' class='tbl-border'>\n";
			echo "<tr>\n<td rowspan='5' width='1%' class='tbl'>".$displayscreen."</td>\n";
			echo "<th class='tbl' width='1%' align='left'>".$locale['gsmp_201']."</td><td class='tbl'>".$ip.":".$port."</td>\n</tr>\n";
			echo "<tr>\n<th class='tbl' width='1%' align='left'>".$locale['gsmp_202']."</td><td class='tbl'>".$numplayers." / ".$maxplayers."</td>\n</tr>\n";
			echo "<tr>\n<th class='tbl' width='1%' align='left'>".$locale['gsmp_203']."</td><td class='tbl'>".$password."</td>\n</tr>\n";
			echo "<tr>\n<th class='tbl' width='1%' align='left'>".$locale['gsmp_204']."</td><td class='tbl'>Counter-Strike ".$gameversion."</td>\n</tr>\n";
			echo "<tr>\n<th class='tbl' width='1%' align='left'>".$locale['gsmp_205']."</td><td class='tbl'>".$map."</td>\n</tr>\n";
			if(!empty($desc)) {echo "<tr>\n<td colspan='3' class='tbl' width='100%' style='border-top:5px;'>".$desc."</td>\n</tr>\n"; }
			echo "</table>\n";
			
			$players = $gameserver->sortPlayers($gameserver->players, "score");
			$i=1;
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='0' border='0' class='tbl-border' style='margin-top:20px;'>\n";
			echo "<tr>\n<td colspan='3' class='forum-caption' style='text-align:center;font-size:12px;font-weight:bold;'><a href='javascript:show_hide(\"players_list\");'>".$locale['gsmp_206']."</a></td>\n</tr>\n";
			echo "</table>\n";
			
			echo "<div id='players_list'>";
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='1' border='0' class='tbl-border'>\n";
			echo "<tr>\n";
			echo "<th align='left' width='1%' class='tbl1'>#</th>\n";
			echo "<th align='left' width='89%' class='tbl1'>".$locale['gsmp_207']."</th>\n";
			echo "<th align='right' width='10%' class='tbl1'>".$locale['gsmp_208']."</th>\n";
			echo "</tr>\n";
				
			foreach($players as $player) {
				$class = ($i % 2 == 0 ? "tbl1" : "tbl2");
				echo "<tr>\n";
				echo "<td align='left' width='1%' class='".$class."'>".$i.".</td>\n";
				echo "<td align='left' width='89%' class='".$class."'>".stripinput($player['name'])."</td>\n";
				echo "<td align='right' width='10%' class='".$class."'>".stripinput($player['score'])."</td>\n";
				echo "</tr>\n"; 
				$i++;
			} 
			echo "</table>\n";
			echo "</div>";
		} else {
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='0' border='0' class='tbl-border' style='margin-top:5px;margin-bottom:5px;'>\n";
			echo "<tr>\n<td class='forum-caption' style='text-align:center;font-size:12px;font-weight:bold;'>".$locale['gsmp_209']."</td>\n</tr>\n";
			echo "</table>\n";
		}
		closetable();
	} else {
		redirect(FUSION_SELF);
	}
} else {
	add_to_title(" - ".$locale['gsmp_221']);
	$result = dbquery("SELECT server_id, server_name, server_ip, server_port, server_pass, server_slots FROM ".DB_GAMESERVERS." ORDER BY server_order");
	opentable($locale['gsmp_210']);
	if(dbrows($result) != 0) {
		echo "<table width='100%' cellpadding='0' cellspacing='0'>\n";
		echo "<tr style='font-weight:bold;' class='tbl'>\n";
		echo "<td width='25%' class='tbl'>".$locale['gsmp_211']."</td>\n";
		echo "<td width='30%' align='center' class='tbl'>".$locale['gsmp_212']."</td>\n";
		echo "<td width='15%' align='center' class='tbl'>".$locale['gsmp_213']."</td>\n";
		echo "<td width='10%' align='center' class='tbl'>".$locale['gsmp_214']."</td>\n";
		echo "<td width='10%' align='center' class='tbl'>".$locale['gsmp_215']."</td>\n";
		echo "</tr>\n";
		$i = 2;
		while($data = dbarray($result)) {
			$class = ($i % 2 == 0 ? "tbl2" : "tbl1");
			$ip = $data['server_ip'];
			$port = $data['server_port'];
			$slots = $data['server_slots'];
			
			if($data['server_pass'] == "") {
				$pass = $locale['gsmp_216'];
			} else {
				$pass = $data['server_pass'];
			}
			
			echo "<tr>\n";
			echo "<td width='25%' class='".$class."'><a href='".INFUSIONS."gameserver_monitor_panel/gameserver_monitor.php?server_id=".$data['server_id']."' title='".$locale['gsmp_217']."' style='text-decoration:underline;'>".$data['server_name']."</a></td>\n";
			echo "<td width='19%' align='center' class='".$class."'>".$slots."</td>\n";
			echo "<td width='30%' align='center' class='".$class."'>".$ip.":".$port."</td>\n";
			echo "<td width='15%' align='center' class='".$class."'>".$pass."</td>\n";
			echo "<td width='10%' align='center' class='".$class."'><a href='hlsw://".$ip.":".$port."' title='".$locale['gsmp_218']."'><img src='".INFUSIONS."gameserver_monitor_panel/images/connect_hlsw.gif' border='0' alt='' width='12' height='12'/></a> <a href='steam://connect/".$ip.":".$port."' title='".$locale['gsmp_219']."'><img src='".INFUSIONS."gameserver_monitor_panel/images/connect_steam.png' border='0' alt='' width='12' height='12'/></a></td>\n";
			echo "</tr>\n";
			$i++;
		}
		echo "</table>\n";
	} else {
			echo "<table align='center' width='70%' cellpadding='0' cellspacing='0' border='0' class='tbl-border' style='margin-top:5px;margin-bottom:5px;'>\n";
			echo "<tr>\n<td colspan='3' class='forum-caption' style='text-align:center;font-size:12px;font-weight:bold;'>".$locale['gsmp_220']."</td>\n</tr>\n";
			echo "</table>\n";
	}
	closetable();
}

require_once THEMES."templates/footer.php";
?>